using System;
using System.Drawing;
using System.Diagnostics;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;

namespace Zakladi
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Panel panelIgra;
		private System.Windows.Forms.Panel panelTop;
		private System.Windows.Forms.GroupBox grpIgralec2;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.GroupBox grpIgralec1;
		private System.Windows.Forms.Label labStatus1;
		private System.Windows.Forms.Label labIme1;
		private System.Windows.Forms.Label labTocke1;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnNovaIgra;
		private System.Windows.Forms.Button btnEnKorak;
		private System.Windows.Forms.PictureBox pbMain;
		private System.Windows.Forms.Label labStatus2;
		private System.Windows.Forms.Label labIme2;
		private System.Windows.Forms.Label labTocke2;
		private System.Windows.Forms.Timer timerNet;
		private System.Windows.Forms.Button btnDisconnect1;
		private System.Windows.Forms.Button btnDisconnect2;
		private System.Windows.Forms.RadioButton rbIgraMala;
		private System.Windows.Forms.RadioButton rbIgraVelika;
		private System.Windows.Forms.Label labSteps;
		private System.Windows.Forms.CheckBox cbAutoRun;
		private System.Windows.Forms.Label labTockeSkupaj2;
		private System.Windows.Forms.Label labTockeSkupaj1;
		private System.Windows.Forms.Button btnResetScore;
		private System.Windows.Forms.LinkLabel labLink;
		private System.Windows.Forms.Label labAbout;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.panelIgra = new System.Windows.Forms.Panel();
			this.cbAutoRun = new System.Windows.Forms.CheckBox();
			this.labSteps = new System.Windows.Forms.Label();
			this.rbIgraVelika = new System.Windows.Forms.RadioButton();
			this.rbIgraMala = new System.Windows.Forms.RadioButton();
			this.btnEnKorak = new System.Windows.Forms.Button();
			this.btnNovaIgra = new System.Windows.Forms.Button();
			this.panelTop = new System.Windows.Forms.Panel();
			this.grpIgralec2 = new System.Windows.Forms.GroupBox();
			this.btnDisconnect2 = new System.Windows.Forms.Button();
			this.labStatus2 = new System.Windows.Forms.Label();
			this.labIme2 = new System.Windows.Forms.Label();
			this.labTocke2 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.grpIgralec1 = new System.Windows.Forms.GroupBox();
			this.btnDisconnect1 = new System.Windows.Forms.Button();
			this.labStatus1 = new System.Windows.Forms.Label();
			this.labIme1 = new System.Windows.Forms.Label();
			this.labTocke1 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.pbMain = new System.Windows.Forms.PictureBox();
			this.timerNet = new System.Windows.Forms.Timer(this.components);
			this.labTockeSkupaj1 = new System.Windows.Forms.Label();
			this.labTockeSkupaj2 = new System.Windows.Forms.Label();
			this.btnResetScore = new System.Windows.Forms.Button();
			this.labLink = new System.Windows.Forms.LinkLabel();
			this.labAbout = new System.Windows.Forms.Label();
			this.panelIgra.SuspendLayout();
			this.panelTop.SuspendLayout();
			this.grpIgralec2.SuspendLayout();
			this.grpIgralec1.SuspendLayout();
			this.SuspendLayout();
			// 
			// panelIgra
			// 
			this.panelIgra.Controls.Add(this.labAbout);
			this.panelIgra.Controls.Add(this.labLink);
			this.panelIgra.Controls.Add(this.btnResetScore);
			this.panelIgra.Controls.Add(this.cbAutoRun);
			this.panelIgra.Controls.Add(this.labSteps);
			this.panelIgra.Controls.Add(this.rbIgraVelika);
			this.panelIgra.Controls.Add(this.rbIgraMala);
			this.panelIgra.Controls.Add(this.btnEnKorak);
			this.panelIgra.Controls.Add(this.btnNovaIgra);
			this.panelIgra.Dock = System.Windows.Forms.DockStyle.Left;
			this.panelIgra.Location = new System.Drawing.Point(0, 0);
			this.panelIgra.Name = "panelIgra";
			this.panelIgra.Size = new System.Drawing.Size(168, 557);
			this.panelIgra.TabIndex = 1;
			// 
			// cbAutoRun
			// 
			this.cbAutoRun.Location = new System.Drawing.Point(8, 176);
			this.cbAutoRun.Name = "cbAutoRun";
			this.cbAutoRun.Size = new System.Drawing.Size(144, 24);
			this.cbAutoRun.TabIndex = 6;
			this.cbAutoRun.Text = "AutoRun";
			this.cbAutoRun.CheckedChanged += new System.EventHandler(this.cbAutoRun_CheckedChanged);
			// 
			// labSteps
			// 
			this.labSteps.Location = new System.Drawing.Point(8, 208);
			this.labSteps.Name = "labSteps";
			this.labSteps.Size = new System.Drawing.Size(136, 16);
			this.labSteps.TabIndex = 5;
			// 
			// rbIgraVelika
			// 
			this.rbIgraVelika.Location = new System.Drawing.Point(8, 64);
			this.rbIgraVelika.Name = "rbIgraVelika";
			this.rbIgraVelika.Size = new System.Drawing.Size(160, 24);
			this.rbIgraVelika.TabIndex = 4;
			this.rbIgraVelika.Text = "100 * 100, 100 zakladov";
			// 
			// rbIgraMala
			// 
			this.rbIgraMala.Checked = true;
			this.rbIgraMala.Location = new System.Drawing.Point(8, 40);
			this.rbIgraMala.Name = "rbIgraMala";
			this.rbIgraMala.Size = new System.Drawing.Size(144, 24);
			this.rbIgraMala.TabIndex = 3;
			this.rbIgraMala.TabStop = true;
			this.rbIgraMala.Text = "20 * 20, 10 zakladov";
			// 
			// btnEnKorak
			// 
			this.btnEnKorak.Location = new System.Drawing.Point(8, 144);
			this.btnEnKorak.Name = "btnEnKorak";
			this.btnEnKorak.Size = new System.Drawing.Size(136, 24);
			this.btnEnKorak.TabIndex = 1;
			this.btnEnKorak.Text = "Odigraj en korak";
			this.btnEnKorak.Click += new System.EventHandler(this.btnEnKorak_Click);
			// 
			// btnNovaIgra
			// 
			this.btnNovaIgra.Location = new System.Drawing.Point(8, 8);
			this.btnNovaIgra.Name = "btnNovaIgra";
			this.btnNovaIgra.Size = new System.Drawing.Size(136, 24);
			this.btnNovaIgra.TabIndex = 0;
			this.btnNovaIgra.Text = "Nova igra";
			this.btnNovaIgra.Click += new System.EventHandler(this.btnNovaIgra_Click);
			// 
			// panelTop
			// 
			this.panelTop.Controls.Add(this.grpIgralec2);
			this.panelTop.Controls.Add(this.grpIgralec1);
			this.panelTop.Dock = System.Windows.Forms.DockStyle.Top;
			this.panelTop.Location = new System.Drawing.Point(168, 0);
			this.panelTop.Name = "panelTop";
			this.panelTop.Size = new System.Drawing.Size(848, 112);
			this.panelTop.TabIndex = 2;
			// 
			// grpIgralec2
			// 
			this.grpIgralec2.Controls.Add(this.labTockeSkupaj2);
			this.grpIgralec2.Controls.Add(this.btnDisconnect2);
			this.grpIgralec2.Controls.Add(this.labStatus2);
			this.grpIgralec2.Controls.Add(this.labIme2);
			this.grpIgralec2.Controls.Add(this.labTocke2);
			this.grpIgralec2.Controls.Add(this.label7);
			this.grpIgralec2.Controls.Add(this.label8);
			this.grpIgralec2.Controls.Add(this.label9);
			this.grpIgralec2.Location = new System.Drawing.Point(424, 8);
			this.grpIgralec2.Name = "grpIgralec2";
			this.grpIgralec2.Size = new System.Drawing.Size(408, 96);
			this.grpIgralec2.TabIndex = 1;
			this.grpIgralec2.TabStop = false;
			this.grpIgralec2.Text = "Igralec 2";
			// 
			// btnDisconnect2
			// 
			this.btnDisconnect2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnDisconnect2.Location = new System.Drawing.Point(8, 64);
			this.btnDisconnect2.Name = "btnDisconnect2";
			this.btnDisconnect2.Size = new System.Drawing.Size(56, 24);
			this.btnDisconnect2.TabIndex = 7;
			this.btnDisconnect2.Text = "Odklopi";
			this.btnDisconnect2.Click += new System.EventHandler(this.btnDisconnect2_Click);
			// 
			// labStatus2
			// 
			this.labStatus2.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labStatus2.Location = new System.Drawing.Point(72, 50);
			this.labStatus2.Name = "labStatus2";
			this.labStatus2.Size = new System.Drawing.Size(232, 35);
			this.labStatus2.TabIndex = 5;
			// 
			// labIme2
			// 
			this.labIme2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labIme2.Location = new System.Drawing.Point(72, 26);
			this.labIme2.Name = "labIme2";
			this.labIme2.Size = new System.Drawing.Size(232, 16);
			this.labIme2.TabIndex = 4;
			// 
			// labTocke2
			// 
			this.labTocke2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labTocke2.Font = new System.Drawing.Font("Tahoma", 20.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.labTocke2.ForeColor = System.Drawing.Color.Red;
			this.labTocke2.Location = new System.Drawing.Point(312, 32);
			this.labTocke2.Name = "labTocke2";
			this.labTocke2.Size = new System.Drawing.Size(88, 32);
			this.labTocke2.TabIndex = 3;
			this.labTocke2.Text = "0.0";
			this.labTocke2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label7
			// 
			this.label7.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label7.Location = new System.Drawing.Point(360, 17);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 16);
			this.label7.TabIndex = 2;
			this.label7.Text = "Tocke:";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(8, 48);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(56, 16);
			this.label8.TabIndex = 1;
			this.label8.Text = "Status:";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(8, 24);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(56, 16);
			this.label9.TabIndex = 0;
			this.label9.Text = "Ime:";
			// 
			// grpIgralec1
			// 
			this.grpIgralec1.Controls.Add(this.labTockeSkupaj1);
			this.grpIgralec1.Controls.Add(this.btnDisconnect1);
			this.grpIgralec1.Controls.Add(this.labStatus1);
			this.grpIgralec1.Controls.Add(this.labIme1);
			this.grpIgralec1.Controls.Add(this.labTocke1);
			this.grpIgralec1.Controls.Add(this.label3);
			this.grpIgralec1.Controls.Add(this.label2);
			this.grpIgralec1.Controls.Add(this.label1);
			this.grpIgralec1.Location = new System.Drawing.Point(8, 8);
			this.grpIgralec1.Name = "grpIgralec1";
			this.grpIgralec1.Size = new System.Drawing.Size(408, 96);
			this.grpIgralec1.TabIndex = 0;
			this.grpIgralec1.TabStop = false;
			this.grpIgralec1.Text = "Igralec 1";
			// 
			// btnDisconnect1
			// 
			this.btnDisconnect1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
			this.btnDisconnect1.Location = new System.Drawing.Point(8, 64);
			this.btnDisconnect1.Name = "btnDisconnect1";
			this.btnDisconnect1.Size = new System.Drawing.Size(56, 24);
			this.btnDisconnect1.TabIndex = 6;
			this.btnDisconnect1.Text = "Odklopi";
			this.btnDisconnect1.Click += new System.EventHandler(this.btnDisconnect1_Click);
			// 
			// labStatus1
			// 
			this.labStatus1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labStatus1.Location = new System.Drawing.Point(72, 50);
			this.labStatus1.Name = "labStatus1";
			this.labStatus1.Size = new System.Drawing.Size(232, 36);
			this.labStatus1.TabIndex = 5;
			// 
			// labIme1
			// 
			this.labIme1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.labIme1.Location = new System.Drawing.Point(72, 26);
			this.labIme1.Name = "labIme1";
			this.labIme1.Size = new System.Drawing.Size(232, 16);
			this.labIme1.TabIndex = 4;
			// 
			// labTocke1
			// 
			this.labTocke1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labTocke1.Font = new System.Drawing.Font("Tahoma", 20.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.labTocke1.ForeColor = System.Drawing.Color.Blue;
			this.labTocke1.Location = new System.Drawing.Point(312, 32);
			this.labTocke1.Name = "labTocke1";
			this.labTocke1.Size = new System.Drawing.Size(88, 32);
			this.labTocke1.TabIndex = 3;
			this.labTocke1.Text = "0.0";
			this.labTocke1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label3.Location = new System.Drawing.Point(360, 20);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Tocke:";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(8, 48);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(56, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Status:";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Ime:";
			// 
			// pbMain
			// 
			this.pbMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.pbMain.Location = new System.Drawing.Point(168, 112);
			this.pbMain.Name = "pbMain";
			this.pbMain.Size = new System.Drawing.Size(848, 445);
			this.pbMain.TabIndex = 3;
			this.pbMain.TabStop = false;
			this.pbMain.Resize += new System.EventHandler(this.pbMain_Resize);
			this.pbMain.Paint += new System.Windows.Forms.PaintEventHandler(this.pbMain_Paint);
			// 
			// timerNet
			// 
			this.timerNet.Interval = 30;
			this.timerNet.Tick += new System.EventHandler(this.timerNet_Tick);
			// 
			// labTockeSkupaj1
			// 
			this.labTockeSkupaj1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labTockeSkupaj1.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.labTockeSkupaj1.ForeColor = System.Drawing.Color.Blue;
			this.labTockeSkupaj1.Location = new System.Drawing.Point(312, 72);
			this.labTockeSkupaj1.Name = "labTockeSkupaj1";
			this.labTockeSkupaj1.Size = new System.Drawing.Size(88, 16);
			this.labTockeSkupaj1.TabIndex = 7;
			this.labTockeSkupaj1.Text = "0.0";
			this.labTockeSkupaj1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// labTockeSkupaj2
			// 
			this.labTockeSkupaj2.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.labTockeSkupaj2.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.labTockeSkupaj2.ForeColor = System.Drawing.Color.Red;
			this.labTockeSkupaj2.Location = new System.Drawing.Point(312, 72);
			this.labTockeSkupaj2.Name = "labTockeSkupaj2";
			this.labTockeSkupaj2.Size = new System.Drawing.Size(88, 16);
			this.labTockeSkupaj2.TabIndex = 8;
			this.labTockeSkupaj2.Text = "0.0";
			this.labTockeSkupaj2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// btnResetScore
			// 
			this.btnResetScore.Location = new System.Drawing.Point(8, 232);
			this.btnResetScore.Name = "btnResetScore";
			this.btnResetScore.Size = new System.Drawing.Size(136, 24);
			this.btnResetScore.TabIndex = 7;
			this.btnResetScore.Text = "Resetiraj tocke";
			this.btnResetScore.Click += new System.EventHandler(this.btnResetScore_Click);
			// 
			// labLink
			// 
			this.labLink.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labLink.Location = new System.Drawing.Point(8, 528);
			this.labLink.Name = "labLink";
			this.labLink.Size = new System.Drawing.Size(152, 16);
			this.labLink.TabIndex = 8;
			this.labLink.TabStop = true;
			this.labLink.Text = "http://rtk.ijs.si/2007/zakladi/";
			this.labLink.LinkClicked += new System.Windows.Forms.LinkLabelLinkClickedEventHandler(this.labLink_LinkClicked);
			// 
			// labAbout
			// 
			this.labAbout.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.labAbout.Location = new System.Drawing.Point(8, 488);
			this.labAbout.Name = "labAbout";
			this.labAbout.Size = new System.Drawing.Size(152, 32);
			this.labAbout.TabIndex = 9;
			this.labAbout.Text = "Lov na zaklade 1.0";
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(1016, 557);
			this.Controls.Add(this.pbMain);
			this.Controls.Add(this.panelTop);
			this.Controls.Add(this.panelIgra);
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.Name = "MainForm";
			this.Text = "Lov na zaklade";
			this.Load += new System.EventHandler(this.MainForm_Load);
			this.panelIgra.ResumeLayout(false);
			this.panelTop.ResumeLayout(false);
			this.grpIgralec2.ResumeLayout(false);
			this.grpIgralec1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		enum TPlayerState
		{
			NotConnected = 0,
			SendSrvInfo = 1,
			RecvAve = 2,
			SendAveConfirm = 3,
			SendQV = 4,
			RecvQVR = 5,
			SendZbudiSe = 6,
			RecvBuden = 7,
			SendKonec = 8,
			SendAdijo = 9,
			OutsideGame = 10, // after SendAveConfirm, before Send[ZbudiSe|Konec|Adijo]
			InGame = 11, // after SendZbudiSe, before SendQV / after RecvQVR, before Send[Konec|Adijo]
		};

		class TPlayer
		{
			public int x, y;
			public int score, totalScore; // divide by 2 to get the real score
			public string name;
			public TPlayerState state;
			public Socket socket;

			public TPlayer()
			{
				x = -1; y = -1; score = 0; totalScore = 0;
				name = ""; state = TPlayerState.NotConnected;
				socket = null;
			}

			// Copies game-related settings but not the socket.
			public TPlayer(TPlayer other)
			{
				x = other.x; y = other.y; score = other.score; totalScore = other.totalScore;
				name = other.name; 
				state = TPlayerState.NotConnected;
				socket = null;
			}

			public string GetStatus()
			{
				switch (state)
				{
					case TPlayerState.NotConnected: return "ni povezave";
					case TPlayerState.SendSrvInfo: return "poiljam podatke o streniku";
					case TPlayerState.RecvAve: return "cakam na ime igralca";
					case TPlayerState.SendAveConfirm: return "poiljam potrditev prijave";
					case TPlayerState.SendQV: return "poiljam vpraanje o premiku";
					case TPlayerState.RecvQVR: return "prebiram premik";
					case TPlayerState.SendZbudiSe: return "poiljam obvestilo o zacetku igre";
					case TPlayerState.RecvBuden: return "cakam na odgovor na obvestilo o zacetku igre";
					case TPlayerState.SendKonec: return "poiljam obvestilo o koncu igre";
					case TPlayerState.SendAdijo: return "poiljam obvestilo o prekinitvi zveze";
					case TPlayerState.OutsideGame: return "povezan, igra ni v teku";
					case TPlayerState.InGame: return "povezan, igra je v teku";
					default: return "???";
				}
			}

			public void EndGame()
			{
				state = TPlayerState.SendKonec;
				SendLine("KONEC_IGRE");
			}

			public void StartGame(TGame game, TPlayer other)
			{
				Debug.Assert(game.w == game.h);
				String s = String.Format("ZBUDI_SE {0} {1} {2} {3} {4} {5}", game.w, game.nTreasures, x, y, other.x, other.y);
				for (int i = 0; i < game.nTreasures; i++)
				{
					int t = game.treasures[i];
					s += String.Format(" {0} {1}", t % game.w, t / game.w);
				}
				score = 0;
				state = TPlayerState.SendZbudiSe;
				SendLine(s);
			}

			public bool moveReceived = false;
			public int xMove, yMove;

			public void SendQV(TPlayer other)
			{
				moveReceived = false;
				xMove = -1; yMove = -1;
				state = TPlayerState.SendQV;
				SendLine(String.Format("QV {0} {1} {2} {3}", x, y, other.x, other.y));
			}

			protected void OnSend(IAsyncResult ar)
			{
				try
				{
					TPlayerState stateOnSend = (TPlayerState) ar.AsyncState;
					socket.EndSend(ar);
					if (stateOnSend == state)
					{
						switch (stateOnSend)
						{
							case TPlayerState.SendSrvInfo: state = TPlayerState.RecvAve; StartRecv(); return;
							case TPlayerState.SendAveConfirm: state = TPlayerState.OutsideGame; return;
							case TPlayerState.SendQV: state = TPlayerState.RecvQVR; StartRecv(); return;
							case TPlayerState.SendZbudiSe: state = TPlayerState.RecvBuden; StartRecv(); return;
							case TPlayerState.SendKonec: state = TPlayerState.OutsideGame; return;
							case TPlayerState.SendAdijo: socket.Close(); socket = null; state = TPlayerState.NotConnected; return;
							default: Debug.WriteLine("OnSend: state = " + stateOnSend + ", wtf?"); return;
						}
					}
				}
				catch (Exception e)
				{
					Debug.WriteLine(e.ToString());
					AbortConn();
				}
			}

			public void OnConnect(Socket socket_)
			{
				if (socket != null) 
				{
					socket.Close(); socket = null; 
				}
				socket = socket_;
				state = TPlayerState.SendSrvInfo;
				SendLine("LovNaZaklade " + Application.ProductVersion);
			}

			public void Disconnect()
			{
				state = TPlayerState.SendAdijo;
				SendLine("ADIJO");
			}

			protected void AbortConn()
			{
				try
				{
					socket.Close(); socket = null;
					state = TPlayerState.NotConnected; 
				}
				catch (Exception e)
				{
					Debug.WriteLine(e.ToString());
				}
			}

			protected void OnRecvLine(string line)
			{
				Debug.WriteLine("Received line \"" + line + "\".");
				switch (state)
				{
					case TPlayerState.RecvAve:
						if (! line.StartsWith("AVE ")) { AbortConn(); return; }
						name = line.Substring(4).Trim();
						state = TPlayerState.SendAveConfirm;
						SendLine("PRIJAVA USPESNA");
						return;
					case TPlayerState.RecvBuden:
						if (! line.StartsWith("BUDEN")) { AbortConn(); return; }
						state = TPlayerState.InGame;
						return;
					case TPlayerState.RecvQVR:
						try
						{
							string[] s = line.Split(' ');
							int dx = int.Parse(s[1]), dy = int.Parse(s[2]);
							if (dx < 0) dx = -1; else if (dx > 0) dx = 1;
							if (dy < 0) dy = -1; else if (dy > 0) dy = 1;
							moveReceived = true; xMove = dx; yMove = dy;
						}
						catch (Exception e)
						{
							Debug.Write(e.ToString());
							AbortConn(); return;
						}
						state = TPlayerState.InGame;
						return;
				}
			}

			const int recvBufLen = 10;
			byte[] recvBuf = null;
			string recvStr = "";

			protected void OnRecv(IAsyncResult ar)
			{
				try
				{
					if (socket == null) return;
					int nReceived = socket.EndReceive(ar);
					char[] c = new char[nReceived];
					for (int i = 0; i < nReceived; i++) 
						c[i] = (char) recvBuf[i];
					string s = new string(c);
					recvStr += s;
					if (nReceived > 0) Debug.Write(s);
					int j = recvStr.IndexOf("\n");
					if (j >= 0)
					{
						string line = recvStr.Substring(0, j);
						recvStr = recvStr.Substring(j + 1);
						OnRecvLine(line);
					}
					else
					{
						socket.BeginReceive(recvBuf, 0, recvBufLen, SocketFlags.None, new AsyncCallback(this.OnRecv), state);
					}
				}
				catch (Exception e)
				{
					Debug.WriteLine(e.ToString());
					AbortConn();
				}
			}

			protected void StartRecv()
			{
				try
				{
					recvBuf = new byte[recvBufLen]; recvStr = "";
					socket.BeginReceive(recvBuf, 0, recvBufLen, SocketFlags.None, new AsyncCallback(this.OnRecv), state);
				}
				catch (Exception e)
				{
					Debug.WriteLine(e.ToString());
					AbortConn();
				}
			}

			protected void SendLine(string s)
			{
				try
				{
					s += "\xd\xa";
					int n = s.Length;
					byte[] b = new byte[n];
					for (int i = 0; i < n; i++)
					{
						int c = s[i];
						if (c < 0 || c > 255) c = 32;
						b[i] = (byte) c;
					}
					Debug.Write("Sending line \"" + s.Trim() + "\".");
					socket.BeginSend(b, 0, n, SocketFlags.None, new AsyncCallback(this.OnSend), this.state);
				}
				catch (Exception e)
				{
					Debug.WriteLine(e.ToString());
					AbortConn();
				}
			}

			
		};

		struct TTile
		{
			public bool treasure;
		};

		class TGame
		{
			public int w, h, nTreasures;
			public int[] treasures;
			public TTile[] state;
			public int nSteps;
			public const int MaxSteps = 10000;

			public TGame(int w_, int h_, int nTreasures_)
			{
				w = w_; h = h_; nTreasures = Math.Min(nTreasures_, w * h - 2);
				state = new TTile[h * w];
				int[] a = new int[h * w]; Random r = new Random();
				for (int i = 0; i < w * h; i++) { 
					int j = r.Next(0, i); a[i] = a[j]; a[j] = i; 
					state[i].treasure = false;
				}
				treasures = new int[nTreasures];
				for (int i = 0; i < nTreasures; i++)
				{
					state[a[i]].treasure = true;
					treasures[i] = a[i];
				}
				nSteps = 0;
			}

			public bool GameOver()
			{
				if (nSteps >= MaxSteps) return true; // out of time
				for (int i = 0; i <nTreasures; i++) 
					if (state[treasures[i]].treasure) return false; // there are some treasures left
				return true; // no treasures left
			}
		};

		TGame game = new TGame(20, 20, 20);
		TPlayer player1 = new TPlayer(), player2 = new TPlayer();
		Socket srvSocket = null;

		void RefreshControls()
		{
			labIme1.Text = player1.name;
			labStatus1.Text = player1.GetStatus();
			labTocke1.Text = (player1.score * 0.5).ToString("0.0");
			labTockeSkupaj1.Text = (player1.totalScore * 0.5).ToString("0.0");
			labIme2.Text = player2.name;
			labStatus2.Text = player2.GetStatus();
			labTocke2.Text = (player2.score * 0.5).ToString("0.0");
			labTockeSkupaj2.Text = (player2.totalScore * 0.5).ToString("0.0");
			if (game != null) labSteps.Text = "T = " + game.nSteps;
			else labSteps.Text = "";
		}

		public void OnAsyncAccept(IAsyncResult ar)
		{
			Debug.Write("OnAsyncAccept");
			TPlayer player = null;
			Socket socket = srvSocket.EndAccept(ar);
			if (player1.socket == null) player = player1;
			else if (player2.socket == null) player = player2;
			else { 
				// We already have two players.
				socket.Close(); 
			}
			player.OnConnect(socket);
			player1.totalScore = 0; player2.totalScore = 0;
			srvSocket.BeginAccept(new AsyncCallback(this.OnAsyncAccept), srvSocket);
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			RefreshControls();
			//
			IPEndPoint ipe = new IPEndPoint(IPAddress.Any, 1175);
			srvSocket = new Socket(ipe.AddressFamily, SocketType.Stream, ProtocolType.Tcp);
			srvSocket.Blocking = false;
			srvSocket.Bind(ipe);
			srvSocket.Listen(10);
			AsyncCallback ac = new AsyncCallback(this.OnAsyncAccept);
			srvSocket.BeginAccept(ac, srvSocket);
			timerNet.Enabled = true;
			labAbout.Text = "Lov na zaklade 1.0\n3. 3. 2007";
		}

		DateTime lastAcceptTime = DateTime.MinValue; 

		private void timerNet_Tick(object sender, System.EventArgs e)
		{
			DateTime now = DateTime.Now;
			if (now.Subtract(lastAcceptTime).TotalSeconds >= 1.0)
			{
				lastAcceptTime = now;
			}
			RefreshControls();
			if (startGameFlag) ProcessStartGame();
			if (moveWaitFlag) ProcessMove();
			else if (cbAutoRun.Checked || playOneStepFlag) ProcessPlayGame();
		}

		void ProcessStartGame()
		{
			//if (player1.state == TPlayerState.NotConnected) return;
			//if (player2.state == TPlayerState.NotConnected) return;
			// Interrupt the current game, if necessary.
			int nOk = 0;
			for (int i = 0; i < 2; i++)
			{
				TPlayer player = (i == 0 ? player1 : player2);
				if (player.state == TPlayerState.InGame)
					player.EndGame();
				else if (player.state == TPlayerState.OutsideGame || player.state == TPlayerState.NotConnected)
					nOk++;
			}
			if (nOk != 2) return;
			// Begin the new game.
			if (rbIgraMala.Checked) game = new TGame(20, 20, 10);
			else game = new TGame(100, 100, 100);
			Random r = new Random();
			int p = 0;
			while (p < 2)
			{
				int x = r.Next(game.w - 1), y = r.Next(game.h - 1);
				if (game.state[y * game.w + x].treasure) continue;
				if (p == 1 && x == player1.x && y == player1.y) continue;
				if (p == 1) { player1.x = x; player1.y = y; }
				else { player2.x = x; player2.y = y; }
				p++;
			}
			if (player1.state != TPlayerState.NotConnected) player1.StartGame(game, player2);
			if (player2.state != TPlayerState.NotConnected) player2.StartGame(game, player1);
			startGameFlag = false;
			pbMain.Invalidate(); pbMain.Refresh();
			moveWaitFlag = false; 
		}

		void ProcessMove()
		{
			if (player1.state != TPlayerState.InGame || player2.state != TPlayerState.InGame) return;
			if (! player1.moveReceived || ! player2.moveReceived) return;
			int x1Old = player1.x, y1Old = player1.y, x2Old = player2.x, y2Old = player2.y;
			player1.x = Math.Max(0, Math.Min(game.w - 1, player1.x + player1.xMove)); 
			player1.y = Math.Max(0, Math.Min(game.h - 1, player1.y + player1.yMove)); 
			player2.x = Math.Max(0, Math.Min(game.w - 1, player2.x + player2.xMove)); 
			player2.y = Math.Max(0, Math.Min(game.h - 1, player2.y + player2.yMove)); 
			int i1 = player1.x + game.w * player1.y, i2 = player2.x + game.w * player2.y;
			bool eat1 = game.state[i1].treasure,  eat2 = game.state[i2].treasure;
			if (eat1 && eat2 && i1 == i2) { player1.score += 1; player2.score += 1; player1.totalScore += 1; player2.totalScore += 1; }
			else 
			{
				if (eat1) { player1.score += 2; player1.totalScore += 2; }
				if (eat2) { player2.score += 2; player2.totalScore += 2; }
			}
			if (eat1) game.state[i1].treasure = false;
			if (eat2) game.state[i2].treasure = false;
			game.nSteps += 1;
			moveWaitFlag = false;
			//
			//pbMain.Invalidate(); pbMain.Refresh();
			Rectangle rc1 = new Rectangle(Math.Min(x1Old, player1.x) - 1, Math.Min(y1Old, player1.y) - 1, Math.Abs(x1Old - player1.x) + 3, Math.Abs(y1Old - player1.y) + 3);
			rc1 = Rectangle.Intersect(rc1, new Rectangle(0, 0, game.w, game.h));
			Rectangle rc2 = new Rectangle(Math.Min(x2Old, player2.x) - 1, Math.Min(y2Old, player2.y) - 1, Math.Abs(x2Old - player2.x) + 3, Math.Abs(y2Old - player2.y) + 3);
			rc2 = Rectangle.Intersect(rc2, new Rectangle(0, 0, game.w, game.h));
			//
			Graphics g = pbMain.CreateGraphics();
			EnsurePbMainBuffer(g);
			DrawGameArea(bmG, rc1);
			DrawGameArea(bmG, rc2);
			BltGameArea(g, rc1); BltGameArea(g, rc2);
			g.Dispose(); 

			if (game.GameOver())
			{
				player1.EndGame();
				player2.EndGame();
				return;
			}
		}

		void ProcessPlayGame()
		{
			if (player1.state != TPlayerState.InGame || player2.state != TPlayerState.InGame) return;
			if (moveWaitFlag) ProcessMove();
			if (! game.GameOver()) 
			{ 
				player1.SendQV(player2);
				player2.SendQV(player1);
				moveWaitFlag = true;
			}
			playOneStepFlag = false; 
		}

		private void btnDisconnect1_Click(object sender, System.EventArgs e)
		{
			player1.Disconnect();
			player1 = new TPlayer(player1);
		}

		private void btnDisconnect2_Click(object sender, System.EventArgs e)
		{
			player2.Disconnect();
			player2 = new TPlayer(player2);
		}

		bool startGameFlag = false, playOneStepFlag = false, moveWaitFlag = false;

		private void btnNovaIgra_Click(object sender, System.EventArgs e)
		{
			startGameFlag = true;
		}

		Bitmap bm = null;
		Graphics bmG = null;
		int pbMain_unit = 5;

		void EnsurePbMainBuffer(Graphics g)
		{
			int cx = pbMain.Width, cy = pbMain.Height;
			if (! (bm != null && bm.Width == cx && bm.Height == cy))  
			{
				bm = new Bitmap(cx, cy, g);
				if (bmG != null) bmG.Dispose();
				bmG = Graphics.FromImage(bm);
			}
		}

		void DrawGameArea(Graphics g, Rectangle r)
		{
			DrawGameArea(g, r.Left, r.Top, r.Width, r.Height);
		}

		void DrawGameArea(Graphics g, int xFrom, int yFrom, int cxGrid, int cyGrid)
		{
			int unit = pbMain_unit;
			g.FillRectangle(new SolidBrush(pbMain.BackColor), xFrom * unit, yFrom * unit, cxGrid * unit + 1, cyGrid * unit + 1);
			Pen pen = new Pen(Color.Black, 1);
			for (int i = xFrom; i <= xFrom + cxGrid; i++)
				g.DrawLine(pen, unit * i, unit * yFrom, unit * i, unit * (yFrom + cyGrid));
			for (int i = yFrom; i <= yFrom + cyGrid; i++)
				g.DrawLine(pen, unit * xFrom, unit * i, unit * (xFrom + cxGrid), unit * i);
			for (int y = yFrom; y < yFrom + cyGrid; y++)
				for (int x = xFrom; x < xFrom + cxGrid; x++)
				{
					bool skip = true; Color c = Color.Black;
					if (x == player1.x && y == player1.y && x == player2.x && y == player2.y) { skip = false; c = Color.Magenta; }
					else if (x == player1.x && y == player1.y) { skip = false; c = Color.Blue; }
					else if (x == player2.x && y == player2.y) { skip = false; c = Color.Red; }
					else if (game.state[y * game.w + x].treasure) { skip = false; c = Color.FromArgb(255, 128, 0); }
					if (! skip) g.FillRectangle(new SolidBrush(c), x * unit + 1, y * unit + 1, unit - 1, unit - 1);
				}
		}

		void BltGameArea(Graphics g, Rectangle rc)
		{
			int unit = pbMain_unit;
			g.DrawImage(bm, new Rectangle(rc.Left * unit, rc.Top * unit, rc.Width * unit + 1, rc.Height * unit + 1), 
				new Rectangle(rc.Left * unit, rc.Top * unit, rc.Width * unit + 1, rc.Height * unit + 1), GraphicsUnit.Pixel);
		}

		private void pbMain_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			int cx = pbMain.Width, cy = pbMain.Height;
			EnsurePbMainBuffer(e.Graphics);
			Graphics g = bmG;
			g.FillRectangle(new SolidBrush(pbMain.BackColor), 0, 0, cx, cy);
			if (game != null)
			{
				int unit = Math.Max(Math.Min((cx - 1) / game.w, (cy - 1) / game.h), 2);
				pbMain_unit = unit;
				DrawGameArea(g, 0, 0, game.w, game.h);
			}
			BltGameArea(e.Graphics, new Rectangle(0, 0, game.w, game.h));
		}

		private void cbAutoRun_CheckedChanged(object sender, System.EventArgs e)
		{
			// ToDo?
		}

		private void btnEnKorak_Click(object sender, System.EventArgs e)
		{
			playOneStepFlag = true;
		}

		private void btnResetScore_Click(object sender, System.EventArgs e)
		{
			player1.totalScore = 0;
			player2.totalScore = 0;
			player1.score = 0;
			player2.score = 0;
		}

		private void labLink_LinkClicked(object sender, System.Windows.Forms.LinkLabelLinkClickedEventArgs e)
		{
			Process.Start(labLink.Text);
		}

		private void pbMain_Resize(object sender, System.EventArgs e)
		{
			pbMain.Invalidate();
			pbMain.Refresh();
		}


	}
}
